%{
  open Ast
  open Printf
  open Lexing
%}

%token <string> VAR
%token <string> LABEL
%token LPAREN RPAREN COMMA QUESTION IF DOT EOF

%type <term> term 
%type <term list> term_list
%type <rule> rule 
%type <rule list> rule_list
%type <Ast.rule list * Ast.term list> program 

%start program
 
%%

term : VAR                            {Var $1}
     | LABEL                          {Term($1,[])}
     | LABEL LPAREN term_list RPAREN  {Term($1,$3)}

term_list :                           {[]}
     | term                           {[$1]}
     | term COMMA term_list           {$1::$3}

rule : term DOT                       {$1, []}
     | term IF term_list DOT          {$1, $3}

rule_list :                           {[]}
     | rule rule_list                 {$1::$2}

program : rule_list 
       QUESTION term_list             {$1,$3}
