open Ast

let print = print_string

let rec
    pprintList = function
    [] -> ()
  | [t] -> pprintTerm t
  | h::t -> pprintTerm h; print ", "; pprintList t

and pprintTerm = function
  | Var n -> print n
  | Term(n, l) ->  print n;
                   if l = [] then ()
                   else (print "("; pprintList l; print ")")

and pprintRule (l,r) =
    pprintTerm l;
    if r != [] then (print " :- "; pprintList r) else ();
    print "."

and pprintProg l = List.map (fun r -> pprintRule r; print "\n") l

